#include "example.hpp"
#include "example-odb.hxx"

TypeBase::assoc_vector
TypeBase::weak_objects()
{
  assoc_vector v;
  for(std::vector<lazy_weak_ptr <TypeAssociated> >::iterator i = weak_association.begin();
      i != weak_association.end(); ++i)
    {
      shared_ptr<TypeAssociated> sh = (*i).load();
      v.push_back(sh);
    }
  return v;
}

TypeBase::assoc_vector
TypeBase::shared_objects()
{
  assoc_vector v;
  for(std::vector<lazy_shared_ptr <TypeAssociated> >::iterator i = shared_association.begin();
      i != shared_association.end(); ++i)
    {
      shared_ptr<TypeAssociated> sh = (*i).load();
      v.push_back(sh);
    }
  return v;
}


void
TypeBase::weak_objects(TypeBase::assoc_vector& v)
{
  weak_association.clear();
  for(assoc_vector::iterator i = v.begin();i != v.end(); ++i)
    {
      weak_association.push_back(*i);
    } 
}

void
TypeBase::shared_objects(TypeBase::assoc_vector& v)
{
  shared_association.clear();
  for(assoc_vector::iterator i = v.begin();i != v.end(); ++i)
    {
      shared_association.push_back(*i);
    } 
}
