#ifndef EXAMPLE_HPP
#define EXAMPLE_HPP

#include <string>
#include <vector>
#include <odb/core.hxx>
#include <iostream>
#include <memory>
#include <odb/tr1/memory.hxx>
#include <odb/tr1/lazy-ptr.hxx>

using odb::tr1::lazy_weak_ptr;
using odb::tr1::lazy_shared_ptr;
using std::tr1::shared_ptr;

#pragma db object
class TypeAssociated{
public:
#pragma db id auto
  unsigned int id;
};

#pragma db object
class TypeBase{
public:
  typedef std::vector<shared_ptr<TypeAssociated> > assoc_vector;
  assoc_vector weak_objects();
  assoc_vector shared_objects();

  void shared_objects(assoc_vector &v);
  void weak_objects(assoc_vector &v);

private:
  friend class odb::access;
#pragma db id auto
  unsigned int id;
  std::vector<lazy_weak_ptr <TypeAssociated> > weak_association;
  std::vector<lazy_shared_ptr <TypeAssociated> > shared_association;
};
#endif
